#include once "image.bi"

namespace nimage


	function load_texture( byref filename as string, Texture() as Texture_Struct, byref force_clamp as Integer, searchDir As String = "res/texture/" ) as integer

		static as integer tcnt

		dim as string tstring
		dim as integer lastslash

		for i as integer = 1 to len(filename)
			if mid(filename,i,1) = "/" then
				lastslash=i
			end if
		next

		tstring = mid(filename, lastslash + 1 )

		if tcnt>0 then
			for i as integer = 1 to ubound( Texture )
				if Texture(i).name = filename then
					return i
				end if
			next
		end if

		tcnt+=1
		redim preserve Texture(tcnt)
		Texture(tcnt).name = tstring
		glgentextures( 1, @Texture(tcnt).img )
		glenable( GL_TEXTURE_2D )
		glbindtexture( GL_TEXTURE_2D, Texture(tcnt).img )

		dim SprWidth as integer
		dim SprHeight as Integer
		dim as any ptr temp

		If Len(searchDir)>0 Then
			png_dimensions( searchDir & tstring, SprWidth, SprHeight )
			temp = png_load( searchDir & tstring, PNG_TARGET_OPENGL )
		EndIf
		
		If temp=0 Then
			png_dimensions( "res/texture/" & tstring, SprWidth, SprHeight )
			temp = png_load( "res/texture/" & tstring, PNG_TARGET_OPENGL )
		EndIf

		glteximage2d( GL_TEXTURE_2D, 0, GL_RGBA, SprWidth, SprHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, temp )

		glubuild2dmipmaps( GL_TEXTURE_2D, GL_RGBA, SprWidth, SprHeight, GL_RGBA, GL_UNSIGNED_BYTE, temp )

		if force_clamp then
			gltexparameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE )
			gltexparameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE )
		else
			gltexparameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT )
			gltexparameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT )
		end if

		gltexparameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR )
		gltexparameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR )
		gltexenvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)


		if use_anisotropic <> 0 then
			dim as glFloat Largest_Texture_Filter
			glgetfloatv( GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, @Largest_Texture_Filter )
			gltexparameterf( GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, Largest_Texture_Filter )
		end if

		png_destroy( temp )

		'close #50

		return tcnt

	End function

end namespace 'nimage
