#include once "fbgfx.bi"
#include once "mathfuncf.bi"
#include once "model.bi"
#include once "image.bi"
#include once "model.bi"
#include Once "objmodel.bi"
#include once "display.bi"
#include once "physics.bi"
#include once "hash.bi"

using ndisplay
using nmodel
using nimage
using nmathf
using nphysics
using nhash

extern Display as Display_Struct
extern h_table	as ht_t ptr

dim as Display_Struct Display
dim as ht_t ptr h_table


Type mousetype
	As Integer x,y,lx,ly,b,lb,r,lr
End Type

declare function main( byval argc as integer, byval argv as zstring ptr ptr ) as integer
declare sub prep_1st_pass()
declare sub render_1st_pass( byref model as model_struct ptr, byref tMatrix as matrix, texture() as texture_struct )
declare sub prep_2nd_pass()
declare sub render_2nd_pass( byref model as model_struct ptr, byref tMatrix as matrix, byref light as light_struct )
declare sub prep_3rd_pass( byref light as light_struct )
declare sub render_3rd_pass( byref model as model_struct ptr, byref tMatrix as matrix, texture() as texture_struct )
declare function project_point( byref old as vec3f ) as vec3f

end main( __fb_argc__, __FB_ARGV__ )


function main( byval argc as integer, byval argv as zstring ptr ptr ) as integer



	open cons for output as #50
	h_table = new ht_t( 256 )

	dim as texture_struct texture(any)
	'redim texture(0)

	dim as integer frame_steps = 60
	dim As double accumulative_step, frequency = 1d/frame_steps, newt_time, time_step

	dim as vmat vCam
	dim as model_struct ptr tmodel(0)
	dim as mousetype		m
	dim as integer 		cam_mode = 0
	dim as integer 		clickX, clickY
	dim as single			zoom = 20, rx, ry, py, px
	dim as light_struct light
	dim as newtonWorld ptr nWorld
	dim as object_struct world
	dim as object_struct crates(50)
	dim as entity_struct plr


	init_gl_window( 1024, 768, 32, 0, 2, 0 )
	
	
	
	init_light( 0, light, type(.25,.25,.25,1f), type(.65,.65,.65,1f), type(.5,.5,.5,1.0), vec4f(250f,250f,250f,1f), vec3f(0f,1f,0f) )
	glEnable( GL_VERTEX_ARRAY ) 'enabled for the duration of the game... the less state switching the better

	'chdir exepath

	dim as string fName' = Command(1)
	fname = "res/model/course1.lwo"
	
	tmodel(0) = load_model3d( fname, Texture(), 0 )


	

	if tModel(0) then
		center_model( tModel(0) )
	end if

	vCam.p = vec3f(0,2,0)
	
	
	do

		time_step = timer - newt_time

		m.lx = m.x : m.ly = m.y : m.lb = m.b : m.lr = m.r
		GetMouse m.x,m.y,m.r,m.b
		If m.x = -1 Then m.x=m.lx : m.y=m.ly : m.r=m.lr : m.b=m.lb
		
		If m.b = 0 andalso m.lb > 0 Then
			SetMouse ,,1
		EndIf

		zoom+=(m.r-m.lr)/3f
		if zoom<0 then zoom = 0
		if zoom>50 then zoom = 50

		if m.b = 1 Then
			py -= (m.y-m.ly)/100f
			px += (m.x-m.lx)/100f
		EndIf

		if m.b = 2 then
			rx += (m.x - m.lx)
			ry += (m.y - m.ly)
		end if

		if m.b > 0 Then
			If ( m.lb = 0 ) Then
				SetMouse display.w2,display.h2,0
				m.x = 512
				m.y = 384
				m.lx = 512
				m.ly = 384
			EndIf
			If ( Abs(m.x-display.w2)>10 ) orElse ( (Abs(m.y-display.h2)>10) ) Then
				SetMouse display.w2,display.h2,0
				m.x = 512
				m.y = 384
				m.lx = 512
				m.ly = 384
			EndIf
		EndIf

		If MultiKey(fb.SC_C) Then
			px = 0
			py = 0
		EndIf

		If MultiKey(fb.SC_R) Then
			px = 0
			py = 0
			zoom = 20
			rx = 0
			ry = 0
		endif
		
		If MultiKey(fb.SC_L) and tModel(0) <> 0  then
			
			for i as integer = 0 to ubound(tmodel)
				unload_model3d( tmodel(i) )
			next

			for i as integer = 0 to ubound(texture)
				glDeleteTextures( 1, @texture(i).img )
			next
			
			redim texture(0)
			
			tmodel(0) = load_model3d( fname, Texture(), 0 )
			
			center_model( tModel(0) )
			
		endif


		glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT )
		
		'i did it this way because i need the matrix to calc the zNormal
		'since we already built a projection matrix, this makes it much easier 
		dim as matrix tMatrix
		tMatrix.LoadIdentity()
		
		tMatrix.Translate( px, py, -zoom )
		tMatrix.Rotate( ry, 0f, 0f )
		tMatrix.Rotate( 0f, rx, 0f )
		
		glLoadMatrixf( tMatrix )
		
		gllightfv( GL_LIGHT0, GL_POSITION, @light.position.x )
		
		if tModel(0) then
			
			glEnable( GL_BLEND )
			glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
			glColor4f( 1,1,1,.5)
			
			glDisable( GL_DEPTH_TEST )
			render_model_tex_only( tmodel(0), texture() )
			glEnable( GL_DEPTH_TEST )
			
			'glDisable( GL_LIGHTING )
			glDisable( GL_TEXTURE_2D )
			glPolygonmode( GL_FRONT, GL_LINE )
			glPolygonmode( GL_BACK, GL_FILL )
			glDisable( GL_BLEND )
			glEnable( GL_POLYGON_OFFSET_FILL )
			glPolygonOffset( 4, 8 )
			glColor3F(1,1,1)
			glDisable( GL_CULL_FACE )
			
			
			for s as integer = 0 to tModel(0)->max_surfaces - 1
			
			
			for t as integer = tModel(0)->surfaces(s).Start_ID to tModel(0)->surfaces(s).End_ID
				
				dim as vec3f p1 = tModel(0)->vertices(tModel(0)->triangles(t).point_id(1))*tMatrix
				dim as vec3f p2 = tModel(0)->vertices(tModel(0)->triangles(t).point_id(2))*tMatrix
				dim as vec3f p3 = tModel(0)->vertices(tModel(0)->triangles(t).point_id(3))*tMatrix
				
				dim as vec3f pp1 = project_point( p1 )
				dim as vec3f pp2 = project_point( p2 )
				dim as vec3f pp3 = project_point( p3 )
				
				dim as single zNormal
				zNormal = ((pp2.X-pp1.X)*(pp1.Y-pp3.Y)-(pp2.Y-pp1.Y)*(pp1.x-pp3.x))
				
				if zNormal<=0 then 
					glColor3f(1,1,0)
				else
					glColor3f(0,0,1)
				endif
				
				glBegin( GL_TRIANGLES )
				if tModel(0)->triangles(t).flagged <> 0 then
					for p as integer = 1 to 3
						
						'If tmodel(0)->vnormals > 0 Then
							'glNormal3fv( @tModel(0)->vNormals(tModel(0)->Triangles(t).point_id(p)).x )
						'Else
							glNormal3fv( @tModel(0)->Triangles(t).vNormals(p).x )
						'endif
						
						glVertex3fv(@tModel(0)->vertices(tModel(0)->triangles(t).point_id(p)).x)
	
					next
				end if
				glEnd()
				
				
			next
			

			next
			
			
			'print #50, "model loaded"
			
			glEnable( GL_CULL_FACE )
			glDisable( GL_POLYGON_OFFSET_LINE )
			glPolygonmode( GL_FRONT_AND_BACK, GL_FILL )
			glEnable( GL_TEXTURE_2D )
			'glEnable( GL_LIGHTING )
			
		end if

		
		flip

		sleep 3,1

	loop until multikey(FB.SC_ESCAPE)

	for i as integer = 0 to ubound(tmodel)
		unload_model3d( tmodel(i) )
	next

	for i as integer = 0 to ubound(texture)
		glDeleteTextures( 1, @texture(i).img )
	next

	'newtonDestroy( nWorld )

	print #50, "OK!"

	sleep 1000, 1

	close #50

	return 0

end function


sub prep_1st_pass()

	glDepthFunc(GL_LESS)
	glDisable(GL_BLEND)
	glDisable(GL_STENCIL_TEST)
	glDepthMask(GL_TRUE)
	glEnable(GL_DEPTH_TEST)
	glEnable(GL_CULL_FACE)
	glCullFace(GL_BACK)
	glEnable(GL_LIGHTING)
	glDisable( GL_LIGHT0 )
	dim as rgbalpha tamb = type( .35, .35, .35, 1.0 )
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @tamb.r)

end sub

sub render_1st_pass( byref model as model_struct ptr, byref tMatrix as matrix, texture() as texture_struct )

	glPushMatrix()
	glMultMatrixf( tMatrix )
	render_model( model, texture() )
	glPopMatrix()

end sub


sub prep_2nd_pass()

	glDepthMask( 0 )
	glEnable( GL_BLEND )
	glBlendFunc( GL_ONE, GL_ONE )
	dim as rgbalpha zamb = type( 0,0,0,0 )
	glLightModelfv( GL_LIGHT_MODEL_AMBIENT, @zamb.r )

	glClear( GL_STENCIL_BUFFER_BIT )
	glColorMask( 0, 0, 0, 0 )
	glEnable( GL_STENCIL_TEST )
	glStencilFunc( GL_ALWAYS, 0, not 0 )
	glStencilMask( not 0 )

end sub

sub render_2nd_pass( byref model as model_struct ptr,  byref tMatrix as matrix, byref light as light_struct )

	if model->shadow_caster <> 0 then

		dim as matrix imat = tMatrix.Inverse()
		dim as vec4f tLp = light.position * imat

		glPushMatrix()
		glMultMatrixf( tMatrix )
		calc_shadow_volume( model, tLp )
		do_shadow_pass( model, tLp )
		glPopMatrix()

	end if

end sub


sub prep_3rd_pass( byref light as light_struct )

	glStencilFunc( GL_EQUAL, 0, not 0 )
	glStencilOp( GL_KEEP, GL_KEEP, GL_INCR )
	glDepthFunc( GL_EQUAL )
	glColorMask( 1,1,1,1 )

	glEnable( GL_LIGHTING )
	glEnable( GL_LIGHT0 )
	glLightModelfv( GL_LIGHT_MODEL_AMBIENT, @light.ambient.r )
	glLightfv( GL_LIGHT0, GL_AMBIENT, @light.ambient.r )
	glLightfv( GL_LIGHT0, GL_DIFFUSE, @light.diffuse.r )
	glLightfv( GL_LIGHT0, GL_SPECULAR, @light.specular.r )

end sub

sub render_3rd_pass( byref model as model_struct ptr, byref tMatrix as matrix, texture() as texture_struct  )

	glPushMatrix()
	glMultMatrixf( tMatrix )
	render_model( model, texture() )
	glPopMatrix()

end sub



function project_point( byref old as vec3f ) as vec3f
	
	dim as vec3f ret

   dim as vec4f tvec = old*display.pmatrix
   dim as vec3f ntvec
    
   dim as single w = 1f / tvec.w
                        
   ntvec.x = tvec.x * w
   ntvec.y = tvec.y * w
   ntvec.z = tvec.z * w
                        
   ret.x = (display.w2 * ntvec.x) + (ntvec.x + display.w2)  
   ret.y = (display.h2 * ntvec.y) + (ntvec.y + display.h2)
   ret.z = (((display.zFar-display.zNear)/2) * ntvec.z) + ((display.zFar+display.zNear)/2)
   
   return ret
 
end function
