#include once "model.bi"
#include once "objmodel.bi"

extern h_table	as nhash.ht_t ptr

namespace nmodel


	sub center_model( model as model_struct ptr )

		dim as nmathf.vec3f centroid

		for v as integer = 0 to model->max_vertices-1
			centroid+=model->vertices(v)
		next

		centroid/=csng(model->max_vertices)

		for v as integer = 0 to model->max_vertices-1
			model->vertices(v)-=centroid
		next

	end sub


	function material_sort_callback cdecl ( byval elm1 as any ptr, byval elm2 as any ptr ) as integer

		return sgn( (cptr(triangle_struct ptr, elm1)->Group) - (cptr(triangle_struct ptr, elm2)->Group) )

	end function


	sub material_sort( byref model as model_struct ptr )

		dim as integer i
		qsort( @Model->triangles(0), Model->max_triangles, sizeof(Triangle_struct), cast(any ptr, @material_sort_callback()) )

		if Model->Max_Surfaces = 1 then
			Model->Surfaces(0).Start_ID = 0
			Model->Surfaces(0).End_ID = Model->Max_Triangles-1
			Model->Surfaces(0).Group = Model->triangles(0).Group
			exit sub
		end if


		dim as integer groupCur, groupCnt
		Model->surfaces(groupCnt).Start_ID = 0
		groupCur = Model->Triangles(0).Group

		i = 0
		do
			if Model->triangles(i).Group <> groupCur then
				Model->surfaces(groupCnt).End_ID = i - 1
				Model->surfaces(groupCnt).Group = Model->triangles(i-1).Group
				groupCnt += 1
				Model->surfaces(groupCnt).Start_ID = i
				Model->surfaces(groupCnt).Group = Model->triangles(i).Group
				groupCur = Model->triangles(i).Group
			end if
			i += 1
		loop until i = Model->max_triangles

		Model->surfaces(groupCnt).End_ID = i - 1
	end sub


	function lwobject_2model3d( byval Object as lwObject ptr, texture() as nimage.texture_struct, byref force_clamp as integer ) as model_struct ptr


		dim as lwLayer ptr layer = @Object->layer[0]
		dim as model_struct ptr Model = new model_struct
		
		dim as integer bone_count, tri_count

		dim as lwPoint ptr pt
		dim as lwPolygon ptr pol
		dim as lwVMap ptr vmap
		dim as byte ptr tag
		dim as integer n

		dim as nmathf.matrix rmatrix
		rmatrix.LoadIdentity()
		rmatrix.Scale(1f,1f,-1f)


		Model->max_vertices  = layer->point.count
		redim Model->vertices(Model->max_vertices)' = new nmathf.vec3f[ Model->max_vertices ]
		redim Model->tvertices(Model->max_vertices)' = new nmathf.vec3f[ Model->max_vertices ]
		redim Model->tangent(Model->max_vertices)' = new nmathf.vec3f[ Model->max_vertices ]
		redim Model->bitangent(Model->max_vertices)' = new nmathf.vec3f[ Model->max_vertices ]
		'Model->vNormals = new vec3f[ Model->max_vertices ]


		'store the object's tag list in an array
		dim as string taglist()
		dim as integer tcnt
		for c as integer = 0 to Object->taglist.count - 1
			redim preserve taglist(tcnt)
			taglist(tcnt) = *Object->taglist.tag[c]
			tcnt+=1
		next


		dim as integer nclips
		dim as lwClip ptr clipnode = Object->clip
		while clipnode
			nclips+=1
			clipnode = clipnode->next
		wend

		dim as string clip_names(nclips)
		nclips=0
		clipnode = Object->clip
		while clipnode
			nclips+=1
			clip_names(nclips) = *clipnode->still.name
			clipnode = clipnode->next
		wend


		for i as integer = 0 to layer->polygon.count - 1
			dim as lwPolygon ptr pol = @layer->polygon.pol[ i ]
			select case pol->type
				case ID_FACE
					Model->max_triangles += 1
				case ID_BONE
					Model->max_bones+=1
			end select
		next

		redim Model->triangles(model->max_triangles)'		= new triangle_struct[ Model->max_triangles ]
		redim Model->Volume(model->max_triangles*3)' 			= new nmathf.vec3f[ Model->max_triangles ]
		redim Model->Volume_CapS(model->max_triangles*3)' 	= new nmathf.vec4f[ Model->max_triangles ]
		redim Model->Volume_CapF(model->max_triangles*3)' 	= new nmathf.vec4f[ Model->max_triangles ]
		redim Model->Volume_CapR(model->max_triangles*3)' 	= new nmathf.vec4f[ Model->max_triangles ]

		'if Model->max_bones>0 then Model->bone = new bone_struct[ Model->max_bones ]
		redim model->bone(model->max_bones)
		for i as integer = 0 to Model->max_bones - 1
			with model->bone(i)
			'Model->bone[i].weight = new single[ Model->max_vertices ]
				redim .weight(Model->max_vertices)
			end with
		next


		dim as lwSurface ptr surf = Object->surf

		do while surf
			if *surf->name <> "Bone" then
				Model->max_surfaces += 1
			end if
			surf = surf->next
		loop

		dim as surface_struct allsurfs( Model->max_surfaces )
		dim as group_struct group( Model->max_surfaces )

		surf = Object->surf
		dim as integer gcnt
		do while surf
			if *surf->name <> "Bone" then
				group(gcnt).name = *surf->name
				group(gcnt).group = gcnt
				group(gcnt).id1 = nimage.load_texture( clip_names(surf->color.tex->imap.cindex), Texture(), force_clamp )

				allsurfs(gcnt).RGBAlpha.R = surf->color._rgb(0)
				allsurfs(gcnt).RGBAlpha.G = surf->color._rgb(1)
				allsurfs(gcnt).RGBAlpha.B = surf->color._rgb(2)
				allsurfs(gcnt).RGBAlpha.A = 1.0-surf->Transparency.val.val

				allsurfs(gcnt).Ambient = type(.5,.5,.5,1.0)

				allsurfs(gcnt).Diffuse.R = surf->Diffuse.val
				allsurfs(gcnt).Diffuse.G = surf->Diffuse.val
				allsurfs(gcnt).Diffuse.B = surf->Diffuse.val
				allsurfs(gcnt).Diffuse.A = surf->Diffuse.val

				allsurfs(gcnt).Specular.R = surf->Specularity.val
				allsurfs(gcnt).Specular.G = surf->Specularity.val
				allsurfs(gcnt).Specular.B = surf->Specularity.val
				allsurfs(gcnt).Specular.A = surf->Specularity.val

				allsurfs(gcnt).shininess = surf->Glossiness.val

				if surf->bump.tex > 0 then
					group(gcnt).bump_id = nimage.load_texture( clip_names(surf->bump.tex->imap.cindex), Texture(), force_clamp )
				end if

				dim as integer gcntlr
				dim as lwTexture ptr thistex = surf->color.tex
				do while thistex

					select case as const gcntlr
						case 1
							group(gcnt).id2 = nimage.load_texture( clip_names(thistex->imap.cindex), Texture(), force_clamp )
						case 2
							group(gcnt).id3 = nimage.load_texture( clip_names(thistex->imap.cindex), Texture(), force_clamp )
						case 3
							group(gcnt).id4 = nimage.load_texture( clip_names(thistex->imap.cindex), Texture(), force_clamp )
					end select

					gcntlr+=1
					thistex = thistex->next
				loop
				'end if

				gcnt+=1

			end if
			surf = surf->next
		loop

		redim Model->Surfaces(Model->Max_Surfaces)' = new Surface_struct[ Model->Max_Surfaces ]



		'initialize the bones
		bone_count = 0
		for i as integer = 0 to layer->polygon.count - 1
			pol = @layer->polygon.pol[ i ]
			select case pol->type
				case ID_FACE
				case ID_BONE
					Model->bone(bone_count).m.LoadIdentity
					'Model->bone[bone_count].m.Translate( layer->point.pt[pol->v[0].index].pos(0), layer->point.pt[pol->v[0].index].pos(1), layer->point.pt[pol->v[0].index].pos(2) )
					Model->bone(bone_count).pos(1) = nmathf.vec3f(layer->point.pt[pol->v[0].index].pos(0), layer->point.pt[pol->v[0].index].pos(1), layer->point.pt[pol->v[0].index].pos(2))
					Model->bone(bone_count).pos(2) = nmathf.vec3f(layer->point.pt[pol->v[1].index].pos(0), layer->point.pt[pol->v[1].index].pos(1), layer->point.pt[pol->v[1].index].pos(2))
					Model->bone(bone_count).m.Translate( Model->bone(bone_count).pos(1) )
					Model->bone(bone_count).pindex(1) = pol->v[0].index
					Model->bone(bone_count).pindex(2) = pol->v[1].index
					'Model->bone[bone_count].id = callocate( len(taglist(pol->part))+1 )
					Model->bone(bone_count).id = taglist(pol->part)
					print #50, Model->bone(bone_count).id
					bone_count += 1

			end select
		next

		dim as morph_struct tmorf()
		redim tmorf(0)

		for i as integer = 0 to layer->polygon.count - 1
			pol = @layer->polygon.pol[i]

			select case pol->type
				case ID_FACE

					for k as integer = 0 to pol->nverts - 1
						n = pol->v[ k ].index
						pt = @layer->point.pt[ n ]

						for j as integer = 0 to pt->nvmaps - 1

							vmap = pt->vm[ j ].vmap
							if ( vmap->perpoly ) then continue for
							n = pt->vm[ j ].index

							if vmap->type = ID_MORF or vmap->type = ID_SPOT then
								'print #50,*vmap->name
								'print #50, vmap->nverts
								'print #50, vmap->val[ n ][ 0 ], vmap->val[ n ][ 1 ], vmap->val[ n ][ 2 ]
								dim as integer no_add

								for m as integer = 0 to ubound(tmorf)

									if *vmap->name = tmorf(m).id then
										no_add = 1
									end if

								next

								if no_add = 0 then
									'print #50, vmap->nverts
									tmorf(ubound(tmorf)).id = *vmap->name
									tmorf(ubound(tmorf)).max_vec = vmap->nverts
									redim preserve tmorf( ubound(tmorf) + 1 )
									'print #50, vmap->vindex[0]'vmap->nverts
								end if

							end if

						next

					next

			end select

		next


		print #50, "max_morphs " & ubound(tmorf)

		if ubound(tmorf)-1>0 then
			model->max_morphs = ubound(tmorf)
			redim model->morphs(model->max_morphs)' = new morph_struct[ model->max_morphs ]
			for i as integer = 0 to model->max_morphs-1
				model->morphs(i).id = tmorf(i).id
				model->morphs(i).max_vec = tmorf(i).max_vec
				'model->morphs(i).vec = new nmathf.vec3f) model->morphs(i).max_vec )
				'model->morphs(i).index = new uinteger( model->morphs(i).max_vec )
				with model->morphs(i)
					redim .vec(model->morphs(i).max_vec)
					redim .index(model->morphs(i).max_vec)
				end with
				print #50, model->morphs(i).id
			next


			for i as integer = 0 to layer->polygon.count - 1
				pol = @layer->polygon.pol[i]

				select case pol->type
					case ID_FACE

						for k as integer = 0 to pol->nverts - 1
							n = pol->v[ k ].index
							pt = @layer->point.pt[ n ]

							for j as integer = 0 to pt->nvmaps - 1

								vmap = pt->vm[ j ].vmap
								if ( vmap->perpoly ) then continue for
								n = pt->vm[ j ].index

								if vmap->type = ID_MORF or vmap->type = ID_SPOT then
									'print #50,*vmap->name
									'print #50, vmap->nverts
									'print #50, vmap->val[ n ][ 0 ], vmap->val[ n ][ 1 ], vmap->val[ n ][ 2 ]
									dim as integer no_add

									for m as integer = 0 to model->max_morphs-1

										if *vmap->name = model->morphs(m).id then
											'no_add = 1
											model->morphs(m).vec(n) = nmathf.vec3f( vmap->val[ n ][ 0 ], vmap->val[ n ][ 1 ], vmap->val[ n ][ 2 ] )*rMatrix
											model->morphs(m).index(n) = vmap->vindex[n]'n
											'print #50, vmap->vindex[n] & " " & n
										end if

									next

									'if no_add = 0 then
									'	tmorf_name(ubound(tmorf_name)) = *vmap->name
									'	redim preserve tmorf_name( ubound(tmorf_name) + 1 )
									'end if

								end if

							next

						next

				end select

			next

		end if







		'the main loop
		for i as integer = 0 to layer->polygon.count - 1
			pol = @layer->polygon.pol[i]

			select case pol->type
				case ID_FACE
					for k as integer = 0 to pol->nverts - 1

						n = pol->v[ k ].index
						pt = @layer->point.pt[ n ]

						Model->triangles(tri_count).point_ID(k+1) = n
						Model->triangles(tri_count).vNormals(k+1) = nmathf.vec3f(pol->v[k].norm(0), pol->v[k].norm(1), pol->v[k].norm(2)) *rMatrix
						Model->triangles(tri_count).vNormals(k+1).Normalize
						Model->vertices(n) = nmathf.vec3f( layer->point.pt[n].pos(0), layer->point.pt[n].pos(1), layer->point.pt[n].pos(2) )*rMatrix

						' vmaps for this vertex
						for j as integer = 0 to pt->nvmaps - 1
							vmap = pt->vm[ j ].vmap
							if ( vmap->perpoly ) then continue for
							n = pt->vm[ j ].index

							if vmap->type = ID_TXUV then

								if *pol->surf->color.tex->imap.vmap_name = *vmap->name then
									Model->triangles(tri_count).t1coord(k+1) = nmathf.vec2f( vmap->val[ n ][ 0 ], vmap->val[ n ][ 1 ] )
								end if
								dim as integer gcntlr
								dim as lwTexture ptr thistex = pol->surf->color.tex
								do while thistex

									if *thistex->imap.vmap_name = *vmap->name then
										select case as const gcntlr
											case 1
												Model->triangles(tri_count).t2coord(k+1) = nmathf.vec2f( vmap->val[ n ][ 0 ], vmap->val[ n ][ 1 ] )
											case 2
												Model->triangles(tri_count).t3coord(k+1) = nmathf.vec2f( vmap->val[ n ][ 0 ], vmap->val[ n ][ 1 ] )
											case 3
												Model->triangles(tri_count).t4coord(k+1) = nmathf.vec2f( vmap->val[ n ][ 0 ], vmap->val[ n ][ 1 ] )
										end select

									end if

									gcntlr+=1
									thistex = thistex->next
								loop

								if pol->surf->bump.tex>0 then
									if *pol->surf->bump.tex->imap.vmap_name = *vmap->name then
										Model->triangles(tri_count).bcoord(k+1) = nmathf.vec2f( vmap->val[ n ][ 0 ], vmap->val[ n ][ 1 ] )
									end if
								end if

							end if

							if vmap->type = ID_WGHT then
								'check the bone name against the name of this vmap
								'if it matches, we know this is the correct weight for this bone.
								for b as integer = 0 to Model->max_bones - 1

									if Model->Bone(b).id = *vmap->name then
										Model->bone(b).weight(n) = vmap->val[ n ][ 0 ]
									end if
								next

							end if

							'if vmap->type = ID_MORF then
							'	print #50, *vmap->name & " found morph target under vmap..."
							'end if


						next j

						' vmads for this vertex
						for j as integer = 0 to pol->v[ k ].nvmaps - 1
							vmap = pol->v[ k ].vm[ j ].vmap
							n = pol->v[ k ].vm[ j ].index

							if vmap->type = ID_TXUV then
								if *pol->surf->color.tex->imap.vmap_name = *vmap->name then
									Model->triangles(tri_count).t1coord(k+1) = nmathf.vec2f( vmap->val[ n ][ 0 ], vmap->val[ n ][ 1 ] )
								end if
								dim as integer gcntlr
								dim as lwTexture ptr thistex = pol->surf->color.tex

								do while thistex

									if *thistex->imap.vmap_name = *vmap->name then

										select case as const gcntlr
											case 1
												Model->triangles(tri_count).t2coord(k+1) = nmathf.vec2f( vmap->val[ n ][ 0 ], vmap->val[ n ][ 1 ] )
											case 2
												Model->triangles(tri_count).t3coord(k+1) = nmathf.vec2f( vmap->val[ n ][ 0 ], vmap->val[ n ][ 1 ] )
											case 3
												Model->triangles(tri_count).t4coord(k+1) = nmathf.vec2f( vmap->val[ n ][ 0 ], vmap->val[ n ][ 1 ] )
										end select

									end if
									gcntlr+=1
									thistex = thistex->next
								loop

								if pol->surf->bump.tex>0 then
									if *pol->surf->bump.tex->imap.vmap_name = *vmap->name then
										Model->triangles(tri_count).bcoord(k+1) = nmathf.vec2f( vmap->val[ n ][ 0 ], vmap->val[ n ][ 1 ] )
									end if
								end if
							end if


							'if vmap->type = ID_MORF then
							'	print #50, *vmap->name & " found morph target under vmad!!!!!!!!!!!!!!!!!!"
							'	sleep 100,1
							'end if

						next j

					next k

					for g as integer = 0 to ubound(group)
						if *pol->surf->name = group(g).name then
							Model->triangles(tri_count).Group = group(g).group
						end if
					next

					'Model->triangles[tri_count].string_id = callocate( len(*pol->surf->name) +1 )
					Model->triangles(tri_count).string_id = *pol->surf->name
					tri_count += 1

			end select

		next i

		for t as integer = 0 to model->max_triangles-1

			swap Model->triangles(t).point_id(1), Model->triangles(t).point_id(3)
			swap Model->triangles(t).t1coord(1), Model->triangles(t).t1coord(3)
			swap Model->triangles(t).t2coord(1), Model->triangles(t).t2coord(3)
			swap Model->triangles(t).t3coord(1), Model->triangles(t).t3coord(3)
			swap Model->triangles(t).t4coord(1), Model->triangles(t).t4coord(3)
			swap Model->triangles(t).bcoord(1), Model->triangles(t).bcoord(3)
			swap Model->triangles(t).vnormals(1), Model->triangles(t).vnormals(3)

			h_table->add( Model->triangles(t).string_id, null )
		next

		material_sort( Model )

		for s as integer = 0 to Model->max_surfaces-1

			Model->Surfaces(s).Is_Bump = 0

			if group(s).bump_id > 0 then
				Model->Surfaces(s).Is_Bump = 1
				Model->Surfaces(s).Texb = group(s).bump_id
			end if

			Model->Surfaces(s).Is_Multi = 0
			Model->Surfaces(s).Tex1 = group(s).id1

			if group(s).id2 > 0 then
				Model->Surfaces(s).Is_Multi = 1
				Model->Surfaces(s).Tex2 = group(s).id2
				Model->Surfaces(s).Tex3 = group(s).id3
				Model->Surfaces(s).Tex4 = group(s).id4
			end if

			'	if Model->Surfaces[s].Is_Multi = 1 and Model->Surfaces[s].Is_Bump = 1 then
			'		print #50, group(s).id1, texture(group(s).id1).name
			'		print #50, group(s).id2, texture(group(s).id2).name
			'		print #50, group(s).id3, texture(group(s).id3).name
			'		print #50, group(s).id4
			'		print #50, group(s).bump_id, texture(group(s).bump_id).name
			'	end if

			Model->Surfaces(s).RGBAlpha  = allsurfs(s).RGBAlpha
			Model->Surfaces(s).Ambient   = allsurfs(s).Ambient
			Model->Surfaces(s).Diffuse   = allsurfs(s).Diffuse 'type(.15,.15,.15,1.0)'
			Model->Surfaces(s).Specular  = allsurfs(s).Specular
			Model->Surfaces(s).Shininess = allsurfs(s).Shininess

			for t as integer = Model->surfaces(s).Start_ID to Model->surfaces(s).End_ID

				for p as integer = 1 to 3
					Model->Triangles(t).vNormals(p).Normalize
				next

				Model->surfaces(s).surfname = Model->triangles(t).string_id

			next



		next

		for b as integer = 0 to model->max_bones-1
			'	for v as integer = 0 to model->max_vertices-1
			'		model->bone[b].weight[v]/=100
			'	next
			swap model->bone(b).pos(1), model->bone(b).pos(2)
		next

		'model->vNormals = 0

		for i as integer = 0 to Model->max_vertices - 1
			model->tvertices(i) = model->vertices(i)
		next

		return Model

	end function


	function load_model3d( byref filename as string, Texture() as nimage.Texture_Struct, byref force_clamp as integer ) as Model_struct ptr

		dim as Model_struct ptr Model
		dim as lwObject ptr Object
		dim as uinteger ptr ErrID
		dim as integer ptr ErrPos
		
		if instr( filename, "skybox") then
			force_clamp = true
		end if
		
		if filename="" then
			print #50, "No model specified"
			return 0

		elseif lcase(right(filename,4)) = ".lwo" then

			Object = lwGetObject( filename, ErrID, ErrPos )

			if Object = 0 then
				beep
				'print #50, "There was an error of " & LWID_2String(*ErrID) & " at " & ErrPos
				return 0
			else
				Model = lwobject_2model3d( Object, Texture(), force_clamp )
				Model->name = filename
				lwFreeObject( Object )
				print #50, filename & " loaded (lwo)"
			end if

			calc_planes( Model )
			calc_normals( Model )
			set_poly_neighbors( Model )

		elseif lcase(right(filename,4)) = ".obj" then

			'model = load3dobj(filename, texture(), force_clamp)

			if model = 0 then
				print #50, "OBJ Loading error on "& filename
				return 0
			endif

			model->name = filename
			print #50, filename & " loaded (obj)"

			calc_planes( Model )
			calc_normals( Model )
			calc_vnormals( Model )
			set_poly_neighbors( Model )
			center_model( model )

		else
			print #50, "unknown file format"
			return 0
		endif
		
		Model->dList = glGenLists(1)
		glNewList( Model->dList, GL_COMPILE )
		render_model( model, texture() )
		glEndList()
		
		
		for s as integer = 0 to model->max_surfaces-1
			model->surfaces(s).dList = glGenLists(1) 
			glNewList( model->surfaces(s).dList, GL_COMPILE )
			render_model_surface( model, texture(), s )
			glEndList()
		next
		
		
		return Model

	end function


	sub unload_model3d( byref Model as Model_struct ptr )

		if Model=0 then exit sub

		'if Model->Vertices > 0 then
		'	delete[]Model->Vertices
		'	Model->Vertices = 0
		'end if

		'if Model->tvertices > 0 then
		'	delete[]Model->tvertices
		'	Model->tvertices = 0
		'end if

		'if Model->vNormals > 0 then
		'	delete[]Model->vNormals
		'	Model->vNormals = 0
		'end if

		'if Model->Volume > 0 then
		'	delete[]Model->Volume
		'	Model->Volume = 0
		'end if

		'if Model->Volume_CapS > 0 then
		'	delete[]Model->Volume_CapS
		'	Model->Volume_CapS = 0
		'end if

		'if Model->Volume_CapF > 0 then
		'	delete[]Model->Volume_CapF
		'	Model->Volume_CapF = 0
		'end if

		'if Model->Volume_CapR > 0 then
		'	delete[]Model->Volume_CapR
		'	Model->Volume_CapR = 0
		'end if
		'
		'if model->tangent then
		'	delete[]Model->tangent
		'	model->tangent = 0
		'end if
		'
		'if model->bitangent then
		'	delete[]Model->bitangent
		'	model->bitangent = 0
		'end if

		'if Model->max_bones>0 then

		'	for i as integer = 0 to Model->max_bones - 1
		'		delete[]Model->Bone[i].Weight
		'		'deallocate( Model->Bone[i].id )
		'	next

		'	delete[]Model->Bone
		'	Model->Bone = 0
		'	model->max_bones = 0
		'end if

		'if model->max_morphs>0 then

		'	for m as integer = 0 to model->max_morphs-1
		'		
		'		if model->morphs[m].vec then
		'			delete[] model->morphs[m].vec
		'		end if
		'		
		'		if model->morphs[m].index then
		'			delete[] model->morphs[m].index
		'		end if
		'		
		'	next

		'	delete[] model->morphs
		'	model->max_morphs = 0

		'end if

		''for i as integer = 0 to Model->max_triangles - 1
		''	deallocate( Model->Triangles[i].string_id )
		''next

		'if model->max_triangles>0 then

		'	if Model->Triangles > 0 then
		'		delete[]Model->Triangles
		'		Model->Triangles = 0
		'	end if

		'	model->max_triangles = 0

		'end if
		'
		'if model->dList<>0 then
		'	glDeleteLists( model->dList, 1 )
		'end if
		'
		'
		'if model->max_surfaces >0 then
		'	
		'	for s as integer = 0 to model->max_surfaces-1
		'		glDeleteLists( model->surfaces[s].dList, 1 )
		'	next
		'	
		'	if Model->Surfaces > 0 then
		'		delete[]Model->Surfaces
		'		Model->Surfaces = 0
		'	end if

		'	model->max_surfaces = 0

		'end if

		'model->max_vertices = 0
		'
		'print #50, Model->name & " removed"
		'delete Model
		'Model = 0

	end sub


	sub render_model( byref model as model_struct ptr, Texture() as nimage.Texture_Struct )

		if model=0 then exit sub

		glPushAttrib( GL_ENABLE_BIT )

		dim as integer surfshade

		for s as integer = 0 to Model->max_surfaces - 1
			surfshade = 0
			if Model->Surfaces(s).Is_Multi > 0 then
				if use_multitex then surfshade = 1
				if Model->Surfaces(s).Is_Bump > 0 then
					if use_shaders then surfshade = 2
				end if
			else
				if Model->Surfaces(s).Is_Bump > 0 then
					if use_shaders then surfshade = 3
				end if
			end if
			
			glEnable( GL_BLEND )
			glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
			
			select case as const surfshade

				case 1
					glEnable( GL_BLEND )
					glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
					glActiveTextureARB( GL_TEXTURE0 )
					glEnable( GL_TEXTURE_2D )
					glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex1).img )

					glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_COMBINE )
					glTexEnvi ( GL_TEXTURE_ENV, GL_COMBINE_RGB,      GL_INTERPOLATE )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE0_RGB,      GL_TEXTURE0 )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND0_RGB,     GL_SRC_COLOR )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE1_RGB,      GL_TEXTURE1 )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND1_RGB,     GL_SRC_COLOR )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE2_RGB,      GL_PRIMARY_COLOR )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND2_RGB,     GL_SRC_ALPHA )

					glActiveTextureARB( GL_TEXTURE1 )
					glEnable( GL_TEXTURE_2D )
					glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex2).img )

					glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_COMBINE )
					glTexEnvi ( GL_TEXTURE_ENV, GL_COMBINE_RGB,      GL_INTERPOLATE )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE0_RGB,      GL_TEXTURE1 )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND0_RGB,     GL_SRC_COLOR )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE1_RGB,      GL_TEXTURE0 )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND1_RGB,     GL_SRC_COLOR )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE2_RGB,      GL_TEXTURE2 )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND2_RGB,     GL_SRC_COLOR )

					glActiveTextureARB( GL_TEXTURE2 )
					glEnable( GL_TEXTURE_2D )
					glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex3).img )

					glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_COMBINE )
					glTexEnvi ( GL_TEXTURE_ENV, GL_COMBINE_RGB,      GL_MODULATE )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE0_RGB,      GL_PREVIOUS )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND0_RGB,     GL_SRC_COLOR )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE1_RGB,      GL_PRIMARY_COLOR )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND1_RGB,     GL_SRC_COLOR )

				case 2
					if _shader100_<>0 then
						glEnable( GL_BLEND )
						glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
						glUseProgramObjectARB( Shader_MultiBump )
						glUniform1iARB(alphamap, 0 )
						glUniform1iARB(colormap1, 1 )
						glUniform1iARB(colormap2, 2 )
						glUniform1iARB(normalmap, 3 )


						glActiveTextureARB( GL_TEXTURE0 )
						glEnable( GL_TEXTURE_2D )
						glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex3).img )

						glActiveTextureARB( GL_TEXTURE1 )
						glEnable( GL_TEXTURE_2D )
						glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex2).img )

						glActiveTextureARB( GL_TEXTURE2 )
						glEnable( GL_TEXTURE_2D )
						glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex1).img )

						glActiveTextureARB( GL_TEXTURE3 )
						glEnable( GL_TEXTURE_2D )
						glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Texb).img )
					end if

				case 3
					if _shader100_<>0 then
						glEnable( GL_BLEND )
						glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
						glUseProgramObjectARB( Shader_Bump )
						glUniform1iARB(DecalLoc, 0 )
						glUniform1iARB(NormalLoc, 1 )

						glActiveTextureARB( GL_TEXTURE0 )
						glEnable( GL_TEXTURE_2D )
						glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex1).img )
						'glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE )
						'glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE0_RGB,      GL_TEXTURE0 )

						glActiveTextureARB( GL_TEXTURE1 )
						glEnable( GL_TEXTURE_2D )
						glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Texb).img )
						'glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE )
						'glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE1_RGB,      GL_TEXTURE1 )
					end if

				case else
					glbindtexture (GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex1).img)

			end select

			glcolor4fv( @Model->surfaces(s).RGBAlpha.R )
			glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT,   @Model->surfaces(s).Ambient.R )
			glMaterialfv( GL_FRONT_AND_BACK, GL_DIFFUSE,   @Model->surfaces(s).Diffuse.R )
			glMaterialfv( GL_FRONT_AND_BACK, GL_SPECULAR,  @Model->surfaces(s).Specular.R )
			glMaterialf ( GL_FRONT_AND_BACK, GL_SHININESS, Model->surfaces(s).Shininess )

			glBegin( GL_TRIANGLES )
			for t as integer = Model->surfaces(s).Start_ID to Model->surfaces(s).End_ID
				for p as integer = 1 to 3
					select case as const surfshade
						case 1
							glMultiTexCoord2fvARB(GL_TEXTURE0, @Model->triangles(t).t1coord(p).x )
							glMultiTexCoord2fvARB(GL_TEXTURE1, @Model->triangles(t).t2coord(p).x )
							glMultiTexCoord2fvARB(GL_TEXTURE2, @Model->triangles(t).t3coord(p).x )

						case 2
							glMultiTexCoord2fvARB(GL_TEXTURE0, @Model->triangles(t).t3coord(p).x )
							glMultiTexCoord2fvARB(GL_TEXTURE1, @Model->triangles(t).t2coord(p).x )
							glMultiTexCoord2fvARB(GL_TEXTURE2, @Model->triangles(t).t1coord(p).x )
							glMultiTexCoord2fvARB(GL_TEXTURE3, @Model->triangles(t).bcoord(p).x )

						case 3
							glMultiTexCoord2fvARB(GL_TEXTURE0, @Model->triangles(t).t1coord(p).x )
							glMultiTexCoord2fvARB(GL_TEXTURE1, @Model->triangles(t).bcoord(p).x )

						case else
							glTexCoord2fv (@Model->triangles(t).t1coord(p).x)

					end select

					'If model->vnormals <> 0 Then
					'glNormal3fv( @Model->vNormals[Model->Triangles[t].point_id(p)].x )
					'Else
					glNormal3fv( @Model->Triangles(t).vNormals(p).x )
					'EndIf
					'glNormal3fv( @Model->Triangles[t].Normal )
					glVertex3fv(@Model->vertices(Model->triangles(t).point_id(p)).x)
				next

			next
			glEnd()

			select case as const surfshade
				case 1
					'glDisable( GL_BLEND )

					glActiveTextureARB( GL_TEXTURE1 )
					glDisable( GL_TEXTURE_2D )

					glActiveTextureARB( GL_TEXTURE2 )
					glDisable( GL_TEXTURE_2D )

					glActiveTextureARB( GL_TEXTURE0 )
					glEnable( GL_TEXTURE_2D )
					glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE )

				case 2
					if _shader100_ <> 0 then
						glUseProgramObjectARB( 0 )

						glActiveTextureARB( GL_TEXTURE1 )
						glDisable( GL_TEXTURE_2D )

						glActiveTextureARB( GL_TEXTURE2 )
						glDisable( GL_TEXTURE_2D )

						glActiveTextureARB( GL_TEXTURE3 )
						glDisable( GL_TEXTURE_2D )

						glActiveTextureARB( GL_TEXTURE0 )
						glEnable( GL_TEXTURE_2D )
						glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE )
					end if

				case 3
					if _shader100_ <> 0 then
						glUseProgramObjectARB( 0 )

						glActiveTextureARB( GL_TEXTURE1 )
						glDisable( GL_TEXTURE_2D )

						glActiveTextureARB( GL_TEXTURE0 )
						glEnable( GL_TEXTURE_2D )
						glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE )
					end if

			end select

		next

		glPopAttrib()

	end sub

	sub render_model_surface( byref model as model_struct ptr, Texture() as nimage.Texture_Struct, s as integer )

		if model=0 then exit sub

		'glPushAttrib( GL_ENABLE_BIT )

		dim as integer surfshade

		'for s as integer = 0 to Model->max_surfaces - 1
			surfshade = 0
			if Model->Surfaces(s).Is_Multi > 0 then
				if use_multitex then surfshade = 1
				if Model->Surfaces(s).Is_Bump > 0 then
					if use_shaders then surfshade = 2
				end if
			else
				if Model->Surfaces(s).Is_Bump > 0 then
					if use_shaders then surfshade = 3
				end if
			end if
			
			glEnable( GL_BLEND )
			glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
			
			select case as const surfshade

				case 1
					glEnable( GL_BLEND )
					glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
					glActiveTextureARB( GL_TEXTURE0 )
					glEnable( GL_TEXTURE_2D )
					glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex1).img )

					glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_COMBINE )
					glTexEnvi ( GL_TEXTURE_ENV, GL_COMBINE_RGB,      GL_INTERPOLATE )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE0_RGB,      GL_TEXTURE0 )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND0_RGB,     GL_SRC_COLOR )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE1_RGB,      GL_TEXTURE1 )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND1_RGB,     GL_SRC_COLOR )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE2_RGB,      GL_PRIMARY_COLOR )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND2_RGB,     GL_SRC_ALPHA )

					glActiveTextureARB( GL_TEXTURE1 )
					glEnable( GL_TEXTURE_2D )
					glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex2).img )

					glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_COMBINE )
					glTexEnvi ( GL_TEXTURE_ENV, GL_COMBINE_RGB,      GL_INTERPOLATE )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE0_RGB,      GL_TEXTURE1 )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND0_RGB,     GL_SRC_COLOR )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE1_RGB,      GL_TEXTURE0 )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND1_RGB,     GL_SRC_COLOR )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE2_RGB,      GL_TEXTURE2 )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND2_RGB,     GL_SRC_COLOR )

					glActiveTextureARB( GL_TEXTURE2 )
					glEnable( GL_TEXTURE_2D )
					glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex3).img )

					glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_COMBINE )
					glTexEnvi ( GL_TEXTURE_ENV, GL_COMBINE_RGB,      GL_MODULATE )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE0_RGB,      GL_PREVIOUS )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND0_RGB,     GL_SRC_COLOR )

					glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE1_RGB,      GL_PRIMARY_COLOR )
					glTexEnvi ( GL_TEXTURE_ENV, GL_OPERAND1_RGB,     GL_SRC_COLOR )

				case 2
					if _shader100_<>0 then
						glEnable( GL_BLEND )
						glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
						glUseProgramObjectARB( Shader_MultiBump )
						glUniform1iARB(alphamap, 0 )
						glUniform1iARB(colormap1, 1 )
						glUniform1iARB(colormap2, 2 )
						glUniform1iARB(normalmap, 3 )


						glActiveTextureARB( GL_TEXTURE0 )
						glEnable( GL_TEXTURE_2D )
						glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex3).img )

						glActiveTextureARB( GL_TEXTURE1 )
						glEnable( GL_TEXTURE_2D )
						glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex2).img )

						glActiveTextureARB( GL_TEXTURE2 )
						glEnable( GL_TEXTURE_2D )
						glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex1).img )

						glActiveTextureARB( GL_TEXTURE3 )
						glEnable( GL_TEXTURE_2D )
						glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Texb).img )
					end if

				case 3
					if _shader100_<>0 then
						glEnable( GL_BLEND )
						glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
						glUseProgramObjectARB( Shader_Bump )
						glUniform1iARB(DecalLoc, 0 )
						glUniform1iARB(NormalLoc, 1 )

						glActiveTextureARB( GL_TEXTURE0 )
						glEnable( GL_TEXTURE_2D )
						glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex1).img )
						'glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE )
						'glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE0_RGB,      GL_TEXTURE0 )

						glActiveTextureARB( GL_TEXTURE1 )
						glEnable( GL_TEXTURE_2D )
						glBindTexture( GL_TEXTURE_2D, Texture(Model->surfaces(s).Texb).img )
						'glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE )
						'glTexEnvi ( GL_TEXTURE_ENV, GL_SOURCE1_RGB,      GL_TEXTURE1 )
					end if

				case else
					glbindtexture (GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex1).img)

			end select
			
			glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT,   @Model->surfaces(s).Ambient.R )
			glMaterialfv( GL_FRONT_AND_BACK, GL_DIFFUSE,   @Model->surfaces(s).Diffuse.R )
			glMaterialfv( GL_FRONT_AND_BACK, GL_SPECULAR,  @Model->surfaces(s).Specular.R )
			glMaterialf ( GL_FRONT_AND_BACK, GL_SHININESS, Model->surfaces(s).Shininess )

			glBegin( GL_TRIANGLES )
			for t as integer = Model->surfaces(s).Start_ID to Model->surfaces(s).End_ID
				for p as integer = 1 to 3
					select case as const surfshade
						case 1
							glMultiTexCoord2fvARB(GL_TEXTURE0, @Model->triangles(t).t1coord(p).x )
							glMultiTexCoord2fvARB(GL_TEXTURE1, @Model->triangles(t).t2coord(p).x )
							glMultiTexCoord2fvARB(GL_TEXTURE2, @Model->triangles(t).t3coord(p).x )

						case 2
							glMultiTexCoord2fvARB(GL_TEXTURE0, @Model->triangles(t).t3coord(p).x )
							glMultiTexCoord2fvARB(GL_TEXTURE1, @Model->triangles(t).t2coord(p).x )
							glMultiTexCoord2fvARB(GL_TEXTURE2, @Model->triangles(t).t1coord(p).x )
							glMultiTexCoord2fvARB(GL_TEXTURE3, @Model->triangles(t).bcoord(p).x )

						case 3
							glMultiTexCoord2fvARB(GL_TEXTURE0, @Model->triangles(t).t1coord(p).x )
							glMultiTexCoord2fvARB(GL_TEXTURE1, @Model->triangles(t).bcoord(p).x )

						case else
							glTexCoord2fv (@Model->triangles(t).t1coord(p).x)

					end select

					'If model->vnormals <> 0 Then
					'glNormal3fv( @Model->vNormals[Model->Triangles[t].point_id(p)].x )
					'Else
					glNormal3fv( @Model->Triangles(t).vNormals(p).x )
					'EndIf
					'glNormal3fv( @Model->Triangles[t].Normal )
					glVertex3fv(@Model->vertices(Model->triangles(t).point_id(p)).x)
				next

			next
			glEnd()

			select case as const surfshade
				case 1
					'glDisable( GL_BLEND )

					glActiveTextureARB( GL_TEXTURE1 )
					glDisable( GL_TEXTURE_2D )

					glActiveTextureARB( GL_TEXTURE2 )
					glDisable( GL_TEXTURE_2D )

					glActiveTextureARB( GL_TEXTURE0 )
					glEnable( GL_TEXTURE_2D )
					glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE )

				case 2
					if _shader100_ <> 0 then
						glUseProgramObjectARB( 0 )

						glActiveTextureARB( GL_TEXTURE1 )
						glDisable( GL_TEXTURE_2D )

						glActiveTextureARB( GL_TEXTURE2 )
						glDisable( GL_TEXTURE_2D )

						glActiveTextureARB( GL_TEXTURE3 )
						glDisable( GL_TEXTURE_2D )

						glActiveTextureARB( GL_TEXTURE0 )
						glEnable( GL_TEXTURE_2D )
						glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE )
					end if

				case 3
					if _shader100_ <> 0 then
						glUseProgramObjectARB( 0 )

						glActiveTextureARB( GL_TEXTURE1 )
						glDisable( GL_TEXTURE_2D )

						glActiveTextureARB( GL_TEXTURE0 )
						glEnable( GL_TEXTURE_2D )
						glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE )
					end if

			end select

		'next

		'glPopAttrib()

end sub

	sub render_model_barebones( byref Model as Model_struct ptr )

		for s as integer = 0 to Model->max_surfaces - 1

			glBegin( GL_TRIANGLES )
			for t as integer = Model->surfaces(s).Start_ID to Model->surfaces(s).End_ID

				for p as integer = 1 to 3

					glVertex3fv(@Model->vertices(Model->triangles(t).point_id(p)).x)

				next

			next
			glEnd()

		next

	end sub


	sub render_model_tex_only( byref Model as Model_struct ptr, texture() as nimage.texture_struct )

		for s as integer = 0 to Model->max_surfaces - 1

			glBindTexture ( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex1).img )

			glBegin( GL_TRIANGLES )
			for t as integer = Model->surfaces(s).Start_ID to Model->surfaces(s).End_ID

				for p as integer = 1 to 3

					'if model->vnormals > 0 then
						'glNormal3fv( @Model->vNormals(Model->Triangles(t).point_id(p)).x )
					'else
						glNormal3fv( @Model->Triangles(t).vNormals(p).x )
					'endif

					glTexCoord2fv (@Model->triangles(t).t1coord(p).x)
					glVertex3fv(@Model->vertices(Model->triangles(t).point_id(p)).x)

				next

			next
			glEnd()

		next

	end sub


	sub render_model_bone_tex_only( byref Model as Model_struct ptr, texture() as nimage.texture_struct )

		for s as integer = 0 to Model->max_surfaces - 1

			glBindTexture ( GL_TEXTURE_2D, Texture(Model->surfaces(s).Tex1).img )

			glBegin( GL_TRIANGLES )
			for t as integer = Model->surfaces(s).Start_ID to Model->surfaces(s).End_ID

				for p as integer = 1 to 3

					'if model->vnormals > 0 then
						glNormal3fv( @Model->vNormals(Model->Triangles(t).point_id(p)).x )
					'else
					'	glNormal3fv( @Model->Triangles[t].vNormals(p).x )
					'endif

					glTexCoord2fv (@Model->triangles(t).t1coord(p).x)
					glVertex3fv(@Model->tvertices(Model->triangles(t).point_id(p)).x)

				next

			next
			glEnd()

		next

	end sub


	sub calc_normals(  Model as Model_struct ptr )

		dim  as nmathf.vec3f Normal, vTriangle(1 to 3)
		dim i as integer, ij as integer

		for i = 0 to Model->max_triangles - 1
			for ij = 1 to 3
				vTriangle(ij).X = Model->vertices(Model->triangles(i).point_Id(ij)).X
				vTriangle(ij).Y = Model->vertices(Model->triangles(i).point_Id(ij)).Y
				vTriangle(ij).Z = Model->vertices(Model->triangles(i).point_Id(ij)).Z
			next

			Model->triangles(i).Normal = nmathf.poly_normal( @vtriangle(1) )

		next

	end sub

	sub calc_vnormals(  Model as Model_struct ptr )

		for i as integer = 0 to Model->max_triangles - 1

			for ij as integer = 1 to 3
				Model->vNormals(Model->triangles(i).point_Id(ij)).X += Model->triangles(i).Normal.X
				Model->vNormals(Model->triangles(i).point_Id(ij)).Y += Model->triangles(i).Normal.Y
				Model->vNormals(Model->triangles(i).point_Id(ij)).Z += Model->triangles(i).Normal.Z
			next

		next

	end sub


	sub calc_planes(  Model as Model_struct ptr )

		dim as integer i
		dim as nmathf.vec3f v1, v2, v3

		for i = 0 to Model->max_triangles-1
			V1.X = Model->vertices(Model->triangles(i).point_Id(1)).X
			V1.y = Model->vertices(Model->triangles(i).point_Id(1)).Y
			V1.Z = Model->vertices(Model->triangles(i).point_Id(1)).Z

			V2.X = Model->vertices(Model->triangles(i).point_Id(2)).X
			V2.y = Model->vertices(Model->triangles(i).point_Id(2)).Y
			V2.Z = Model->vertices(Model->triangles(i).point_Id(2)).Z

			V3.X = Model->vertices(Model->triangles(i).point_Id(3)).X
			V3.y = Model->vertices(Model->triangles(i).point_Id(3)).Y
			V3.Z = Model->vertices(Model->triangles(i).point_Id(3)).Z

			Model->triangles(i).Plane.X = v1.y * (v2.z-v3.z) + v2.y * (v3.z-v1.z) + v3.y * (v1.z-v2.z)
			Model->triangles(i).Plane.Y = v1.z*(v2.x-v3.x) + v2.z*(v3.x-v1.x) + v3.z*(v1.x-v2.x)
			Model->triangles(i).Plane.Z = v1.x*(v2.y-v3.y) + v2.x*(v3.y-v1.y) + v3.x*(v1.y-v2.y)
			Model->triangles(i).Plane.W = -( v1.x*( v2.y*v3.z - v3.y*v2.z ) + v2.x*(v3.y*v1.z - v1.y*v3.z) + v3.x*(v1.y*v2.z - v2.y*v1.z) )
		next

	end sub


	sub set_poly_neighbors( Model as Model_struct ptr )
		dim as integer f, f2
		dim as integer i, ij
		dim as integer Hitcnt
		dim as integer P1a, P1b, P2a, P2b, C1a, C2a, C1b, C2b

		for f = 0 to Model->max_triangles-1
			for i = 1 to 3
				Model->triangles(f).Con(i) = -1
			next
		next

		for f = 0 to Model->max_triangles-2
			for f2 = f+1 to Model->max_triangles-1
				for i = 1 to 3
					if Model->triangles(f).Con(i) = -1 then
						for ij = 1 to 3

							P1a = i
							P1b = ij
							P2a = (P1a mod 3) + 1
							P2b = (P1b mod 3) + 1

							P1a = Model->triangles(f).Point_ID(P1a)
							P2a = Model->triangles(f).Point_ID(P2a)
							P1b = Model->triangles(f2).Point_ID(P1b)
							P2b = Model->triangles(f2).Point_ID(P2b)

							C1a=((P1a+P2a) - abs(P1a-P2a)) \ 2
							C2a=((P1a+P2a) + abs(P1a-P2a)) \ 2
							C1b=((P1b+P2b) - abs(P1b-P2b)) \ 2
							C2b=((P1b+P2b) + abs(P1b-P2b)) \ 2

							if (C1a = C1b) and (C2a = C2b) then
								Model->triangles(f).Con(i) = f2+1
								Model->triangles(f2).Con(ij) = f+1
							end if

						next
					end if
				next
			next
		next

		Model->shadow_caster = 1

		for f = 0 to Model->max_triangles-1
			for i = 1 to 3
				if Model->triangles(f).Con(i) = -1 then
					#ifdef con_print
						print #50, "model not connected properly at triangle index " & f
					#endif
					Model->triangles(f).flagged = 1
					'Model->shadow_caster = 0
					'exit for, for
				end if
			next
		next


	end sub


	sub do_shadow_pass_wCaps( Model as Model_struct ptr, byref lp as nmathf.vec4f )

		if GL_DEPTH_CLAMP_NV then
			'glenable( GL_DEPTH_CLAMP_NV )
		end if

		glcullface( GL_FRONT )
		glstencilop( GL_KEEP, GL_INCR, GL_KEEP )
		render_quick_volume_wCaps( Model )

		glcullface( GL_BACK )
		glstencilop( GL_KEEP, GL_DECR, GL_KEEP )
		render_quick_volume_wCaps( Model )



		if GL_DEPTH_CLAMP_NV then
			'gldisable( GL_DEPTH_CLAMP_NV )
		end if

	end sub


	sub calc_shadow_volume_wCaps ( byval Model as Model_struct ptr, byref lp as nmathf.vec4f )


		for i as integer = 0 to Model->max_triangles-1
			Model->triangles(i).visible = 0
			if Model->triangles(i).Plane.dot(Lp) > 0f then Model->triangles(i).visible = 1
		next

		dim as integer p1, p2, j, jj, f_Hits, Cap_r_Hits, Cap_f_Hits
		dim as nmathf.vec3f v1,v2,v3,v4, t1, t2

		with *Model

			for i as integer = 0 to .max_triangles-1
				if .triangles(i).visible > 0 then
					for j=1 to 3
						dim as integer k = .triangles(i).con(j)

						if k = 0 or .triangles(k-1).Visible = 0 then
							'if .triangles[k-1].invisible = 0 then
							p1 = .triangles(i).Point_Id(j)
							JJ = J+1
							if JJ>3 then JJ = 1

							p2 = .triangles(i).Point_Id(jj)

							dim as nmathf.vec4f a = nmathf.vec4f( .vertices(p1).x, .vertices(p1).y, .vertices(p1).z, 1f )
							dim as nmathf.vec4f b = nmathf.vec4f( .vertices(p2).x, .vertices(p2).y, .vertices(p2).z, 1f )

							.volume_CapS(f_Hits) = b
							.volume_CapS(f_Hits+1) = a
							.volume_CapS(f_Hits+2) = nmathf.vec4f(A.x*Lp.w-Lp.x*A.w, A.y*Lp.w-Lp.y*A.w, A.z*Lp.w-Lp.z*A.w, 0f)
							.volume_CapS(f_Hits+3) = nmathf.vec4f(B.x*Lp.w-Lp.x*B.w, B.y*Lp.w-Lp.y*B.w, B.z*Lp.w-Lp.z*B.w, 0f)

							f_Hits+=4
							'end if
						end if

					next

					for t as integer = 1 to 3

						dim as integer tt = .triangles(i).point_ID(t)
						dim as nmathf.vec4f v = nmathf.vec4f( .vertices(tt).x, .vertices(tt).y, .vertices(tt).z, 1f )
						.Volume_CapF(Cap_f_Hits) = v
						Cap_f_Hits+=1

					next
				else

					for t as integer = 1 to 3

						dim as integer tt = .triangles(i).point_ID(t)
						dim as nmathf.vec4f v = nmathf.vec4f( .vertices(tt).x, .vertices(tt).y, .vertices(tt).z, 1f )
						.Volume_CapR(Cap_r_Hits) = nmathf.vec4f(V.x*Lp.w-Lp.x*V.w, V.y*Lp.w-Lp.y*V.w, V.z*Lp.w-Lp.z*V.w, 0f)
						Cap_r_Hits+=1

					next

				end if
			next

			.fCnt = f_Hits
			.Cap_rCnt = Cap_r_Hits
			.Cap_fCnt = Cap_f_Hits
		end with

	end sub


	sub render_quick_volume_wCaps( Model as Model_struct ptr )

		glvertexpointer( 4,  GL_FLOAT,  0, @Model->Volume_CapS(0).x )
		gldrawarrays(GL_QUADS, 0, Model->fCnt )

		glvertexpointer( 4,  GL_FLOAT,  0, @Model->Volume_CapR(0).x )
		gldrawarrays(GL_TRIANGLES, 0, Model->Cap_rCnt )

		glvertexpointer( 4,  GL_FLOAT,  0, @Model->Volume_CapF(0).x )
		gldrawarrays(GL_TRIANGLES, 0, Model->Cap_fCnt )

	end sub


	sub Do_Shadow_Pass( Model as Model_struct ptr, byval lp as nmathf.Vec4f )

		dim as uinteger	i
		dim as Gluint List

		for i = 0 to Model->max_triangles-1
			
			'If Vector_Dot( Model->triangles[i].Plane, Lp ) > 0 Then Model->triangles[i].visible = 1
			if Model->triangles(i).Plane.dot(Lp) > 0 then 
				Model->triangles(i).visible = -1
			else
				Model->triangles(i).visible = 0
			end if

		next
		
		if model->static_shadows then
			if model->volume_created = 0 then
				model->volume_created = true
				Calc_Shadow_Volume( Model, lp )
			end if
		else
			Calc_Shadow_Volume( Model, lp )
		end if
		
		if _stencil2_ = 0 then
			
		 
		if GL_DEPTH_CLAMP_NV then
			glEnable( GL_DEPTH_CLAMP_NV )
		end if
		
		'glEnable( GL_POLYGON_OFFSET_FILL )
		'glPolygonOffset( 1, 1000 )
		glCullFace( GL_FRONT )
		glStencilOp(GL_KEEP, GL_KEEP, GL_INCR_WRAP)
		Render_Quick_Volume( Model )

		glCullFace( GL_BACK )
		glStencilOp(GL_KEEP, GL_KEEP, GL_DECR_WRAP)
		Render_Quick_Volume( Model )
		'glDisable( GL_POLYGON_OFFSET_FILL )
		
		if GL_DEPTH_CLAMP_NV then
			glDisable( GL_DEPTH_CLAMP_NV )
		end if
		
		else
		
		glDepthMask(0)
      glColorMask(0,0,0,0)
      glDisable(GL_CULL_FACE)
      glEnable(GL_STENCIL_TEST)
      glEnable(GL_STENCIL_TEST_TWO_SIDE_EXT)

      glActiveStencilFaceEXT(GL_BACK)
      glStencilOp(GL_KEEP, GL_KEEP, GL_DECR_WRAP_EXT)
      glStencilMask(not 0)
      glStencilFunc(GL_ALWAYS, 0, not 0)

      glActiveStencilFaceEXT(GL_FRONT)
      glStencilOp(GL_KEEP, GL_KEEP, GL_INCR_WRAP_EXT)
      glStencilMask( not 0)
      glStencilFunc(GL_ALWAYS, 0, not 0)
		Render_Quick_Volume( Model )
		
		end if
		
	end sub

	
	sub Render_Quick_Volume( Model as Model_struct ptr )
		
		glvertexpointer( 3,  GL_FLOAT,  0, @Model->Volume(0).x )
		gldrawarrays(GL_TRIANGLES, 0, Model->fCnt )
		
	end sub
	
	sub Calc_Shadow_Volume( Model as Model_struct ptr, byref lp as nmathf.vec4f )
		dim as integer i = any, p1 = any, p2 = any, j= any, jj = any, k = any, f_Hits
		static as nmathf.vec3f v1,v2,v3,v4

	static as nmathf.vec3f ptr tvol

	with *model
		for i=0 to .max_triangles-1
			if .triangles(i).visible then
				for j=1 to 3
					k = .triangles(i).con(j)
					if k>-1 then
					if k = 0 or .triangles(k-1).Visible = 0 then
						p1 = .triangles(i).Point_Id(j)
						JJ = J+1
						if JJ>3 then JJ = 1

						p2 = .triangles(i).Point_Id(jj)
						
						
						v3 = (.vertices(p1) - lp) * Shadow_Infinity
						v4 = (.vertices(p2) - lp) * Shadow_Infinity
						
						tvol = @.Volume(f_Hits)
						
						*tvol = .vertices(p1)
						tvol+=1
						*tvol = v3
						tvol+=1
						*tvol = .vertices(p2)
						tvol+=1
						
						*tvol = .vertices(p2)
						tvol+=1
						*tvol = v3
						tvol+=1
						*tvol = v4
						
						
						f_Hits+=6
					end if
					end if
				next
			end if
		next
		
		.fCnt = f_Hits
		
	end with
		
	end sub

	sub Begin_Shadow_Pass()
		Glclear( GL_STENCIL_BUFFER_BIT )
		glDisable(GL_LIGHTING)
		glDepthMask(GL_FALSE)
		glDepthFunc(GL_LEQUAL)

		glEnable(GL_STENCIL_TEST)
		glColorMask(0, 0, 0, 0)
		glStencilFunc(GL_ALWAYS, 1, &hffffffff)
	end sub


end namespace
