#include "objmodel.bi"


#if 0

Function getFN(fn As String) As String
	Dim As Integer		lastF=0, lastB=0
	
	lastF = InStr(fn,"/")
	Do While InStr(lastF+1,fn,"/")
		lastF = InStr(lastF+1,fn,"/")
	Loop
	
	lastB = InStr(fn,"\")
	Do While InStr(lastB+1,fn,"\")
		lastB = InStr(lastB+1,fn,"\")
	Loop
	
	If lastF+lastB = 0 Then Return fn
	
	If lastF>lastB Then
		Return Mid(fn,lastF+1)
	Else
		Return Mid(fn,lastB+1)
	EndIf
	
End Function

Function getDir(fn As String) As String
	Dim As Integer		lastF=0, lastB=0
	
	lastF = InStr(fn,"/")
	Do While InStr(lastF+1,fn,"/")
		lastF = InStr(lastF+1,fn,"/")
	Loop
	
	lastB = InStr(fn,"\")
	Do While InStr(lastB+1,fn,"\")
		lastB = InStr(lastB+1,fn,"\")
	Loop
	
	If lastF>lastB Then
		Return Mid(fn,1,lastF)
	Else
		Return Mid(fn,1,lastB)
	EndIf
	
End Function

Function getSurfByName(model As nmodel.model_struct ptr, surfName As String) As Integer
	
	For c As Integer = 0 To model->max_surfaces
		If model->surfaces(c).surfName = surfName Then Return c
	Next
	
	Return -1

End Function

Sub loadMaterialByName( ByRef surf As nmodel.surface_struct, mtlFile As String, materialName As String, texture() As nimage.texture_struct, force_clamp As Integer, objDir As String = "" )

	Dim As Integer		ff = FreeFile, NormIn
	Dim As String		rec

	Open mtlFile For Binary Access Read As #ff
	Do While Not Eof(ff)
		Line Input #ff, rec
		If Len(rec)<7 Then Continue Do
		If rec[0] = 35 Then Continue Do
		If Mid(rec,1,7) = "newmtl " andAlso Mid(rec, 8) = materialName Then

			surf.surfName = Mid(rec,8)

			Line Input #ff, rec
			Do While Len(rec)>0

				If rec[0] = 35 Then
					Line Input #ff, rec
					Continue Do
				EndIf

				If Mid(rec,1,3) = "Kd " Then
					NormIn = 0
					For i As Integer = 1 To Len(Rec)
						If MID$(Rec, i, 1) = " " Then                  
							NormIn = NormIn + 1
							Select Case As Const NormIn
								Case 1
									surf.diffuse.r = Val(MID(Rec, i + 1))
								Case 2
									surf.diffuse.g = Val(MID(Rec, i + 1))
								Case 3
									surf.diffuse.b = Val(MID(Rec, i + 1))
									surf.diffuse.a = 1
							End Select    
						End If
					Next
				EndIf
				If Mid(rec,1,3) = "Ka " Then
					NormIn = 0
					For i As Integer = 1 To Len(Rec)
						If MID$(Rec, i, 1) = " " Then                  
							NormIn = NormIn + 1
							Select Case As Const NormIn
								Case 1
									surf.Ambient.r = Val(MID(Rec, i + 1))
								Case 2
									surf.Ambient.g = Val(MID(Rec, i + 1))
								Case 3
									surf.Ambient.b = Val(MID(Rec, i + 1))
									surf.Ambient.a = 1
							End Select    
						End If
					Next
				EndIf
				If Mid(rec,1,3) = "Ks " Then
					NormIn = 0
					For i As Integer = 1 To Len(Rec)
						If MID$(Rec, i, 1) = " " Then                  
							NormIn = NormIn + 1
							Select Case As Const NormIn
								Case 1
									surf.Specular.r = Val(MID(Rec, i + 1))
								Case 2
									surf.Specular.g = Val(MID(Rec, i + 1))
								Case 3
									surf.Specular.b = Val(MID(Rec, i + 1))
									surf.Specular.a = 1
							End Select    
						End If
					Next
				EndIf
				If Mid(rec,1,7) = "map_Kd " Then
					surf.RGBAlpha.r = .8
					surf.RGBAlpha.g = .8
					surf.RGBAlpha.b = .8
					surf.RGBAlpha.a = 1

					surf.tex1 = nimage.load_texture( getFN(Mid(rec,8)), Texture(), force_clamp, objDir)
		
				EndIf

				Line Input #ff, rec
			Loop
			Exit Sub

		EndIf
	Loop
	Close #ff
	
End Sub


Function load3dOBJ(filename As String, texture() As nimage.Texture_Struct, force_clamp As Integer) As nmodel.Model_struct ptr
	
	Dim As nmodel.model_struct ptr		model = new nmodel.model_struct
	Dim As Integer					Total_Vertices, Total_Faces, uvCnt, totalGroups, totalObj, Total_Surfaces, _
										fn = FreeFile, activeTriangle, activeVertex, curSurf = -1, normIn, TempUVFace
	Dim As String					rec, mtlLib, activeMtl, tst, groupName, objDir
	Dim As nmathf.vec2f ptr				texUVs
	
	objDir = getDir(filename)
	model->file_name = getFN(filename)
	
	Open filename For Binary As #fn
	Do While Not Eof(fn)
		Line Input #fn, rec
		Select Case Mid(rec,1,2)
			Case "v "
				model->max_vertices+=1
			Case "f "
				model->max_triangles+=1
			Case "vt"
				uvCnt += 1
		End Select
'		If Mid(rec,1,2) = "g " Then model->max_surfaces+=1
'		If Mid(rec,1,2) = "o " Then totalObj+=1
		If Mid(rec,1,7) = "usemtl " Then model->max_surfaces+=1
		If Mid(rec,1,7) = "mtllib " Then
			mtlLib = Mid(rec,8)
		EndIf
	Loop
	Close #fn

'	If Len(mtlLib)>0 Then
'		model->max_surfaces += loadMTLLib(mtlLib, model, texture(), force_clamp, model->max_surfaces)
'	EndIf

	texUVs = new nmathf.vec2f[uvCnt]
	model->vertices = new nmathf.vec3f[model->max_vertices]
	model->vnormals = new nmathf.vec3f[model->max_vertices]
	model->triangles = new nmodel.triangle_struct[model->max_triangles]
	model->surfaces = new nmodel.surface_struct[model->max_surfaces]
	
	Model->Volume 		 = new nmathf.vec3f[ Model->max_triangles * 3 ]
	model->volume_CapS = new nmathf.vec4f[ Model->max_triangles * 3 ]
	model->volume_CapF = new nmathf.vec4f[ Model->max_triangles * 3 ]
	model->volume_CapR = new nmathf.vec4f[ Model->max_triangles * 3 ]
	
	Open filename For Binary As #fn
		Do While Not Eof(fn)
			
			Line Input #fn, rec
			If Len(rec)<2 Then Continue Do
			If rec[0] = 35 Then Continue Do
			
			If (Mid(rec,1,2) = "g ") Then
				groupName = Mid(rec,3)
			EndIf

			If (Len(rec)>7) andalso (Mid(Rec, 1, 7) = "usemtl ") Then

				If curSurf>-1 Then
					model->surfaces[curSurf].end_id = activeTriangle-1
				EndIf

				'curSurf = getSurfByName(model, activeMtl)
				curSurf += 1
				Print #50, "Loading "& objDir & mtlLib
				loadMaterialByName( model->surfaces[curSurf] , objDir & mtlLib, Mid(rec,8), texture(), force_clamp, objDir )
				model->surfaces[curSurf].surfName = groupName
				model->surfaces[curSurf].start_id = activeTriangle
				
				Continue Do
			EndIf
			
			Select Case Mid(Rec, 1, 2)
				Case "v "         
					NormIn = 0
					For i As Integer = 1 To Len(Rec)
						If MID$(Rec, i, 1) = " " Then                  
							NormIn = NormIn + 1
							Select Case NormIn
								Case 1
									Model->vertices[activeVertex].X = Val(MID(Rec, i + 1))
								Case 2
									Model->vertices[activeVertex].Y = Val(MID(Rec, i + 1))
								Case 3
									Model->vertices[activeVertex].Z = Val(MID(Rec, i + 1))
							End Select    
						End If
					Next
					activeVertex += 1
				Case "f "
					NormIn = 0
					For i As Integer = 1 To Len(Rec)
						If MID$(Rec, i, 1) = " " Then                  
							NormIn = NormIn + 1
							tst = MID(Rec, i + 1)
							Model->triangles[activeTriangle].Point_id(NormIn) = Val(tst)-1
							If Val(Mid(tst,InStr(tst,"/")+1)) < 0 Then
								model->triangles[activeTriangle].t1coord(NormIn).x = texUVs[tempUVFace+Val(Mid(tst,InStr(tst,"/")+1))].x
								model->triangles[activeTriangle].t1coord(NormIn).y = texUVs[tempUVFace+Val(Mid(tst,InStr(tst,"/")+1))].y
							Else
								model->triangles[activeTriangle].t1coord(NormIn).x = texUVs[Val(Mid(tst,InStr(tst,"/")+1))-1].x
								model->triangles[activeTriangle].t1coord(NormIn).y = texUVs[Val(Mid(tst,InStr(tst,"/")+1))-1].y
							EndIf
						End If
					Next
					activeTriangle += 1
				Case "vt"
					texUVs[tempUVFace].x = Val(Mid(rec,InStr(rec," ")+1))
					texUVs[TempUVFace].Y = Val(Mid(rec,4+InStr(Mid(rec,4)," ")+1))
					TempUVFace += 1
			End Select			

		Loop
	Close #fn	

	delete[]texUVs
	model->surfaces[curSurf].end_id = activeTriangle-1
	model->max_surfaces = curSurf+1

	Return model

End Function

#endif
